package com.fjhx.sale.service.documents.impl;

import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.fjhx.sale.entity.documents.po.Documents;
import com.fjhx.sale.entity.documents.po.DocumentsPdf;
import com.fjhx.sale.mapper.documents.DocumentsPdfMapper;
import com.fjhx.sale.service.documents.DocumentsPdfService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.sale.service.documents.DocumentsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.sale.entity.documents.vo.DocumentsPdfVo;
import com.fjhx.sale.entity.documents.dto.DocumentsPdfSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.sale.entity.documents.dto.DocumentsPdfDto;
import cn.hutool.core.bean.BeanUtil;


/**
 * <p>
 * 单证PDF数据存放表 服务实现类
 * </p>
 *
 * @author 
 * @since 2023-04-26
 */
@Service
public class DocumentsPdfServiceImpl extends ServiceImpl<DocumentsPdfMapper, DocumentsPdf> implements DocumentsPdfService {

    @Autowired
    private DocumentsService documentsService;

    @Override
    public Page<DocumentsPdfVo> getPage(DocumentsPdfSelectDto dto) {
        IWrapper<DocumentsPdf> wrapper = getWrapper();
        wrapper.orderByDesc("dp", DocumentsPdf::getId);
        Page<DocumentsPdfVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    /**
     * 查询详情
     * @param id 单证ID
     * @return
     */
    @Override
    public DocumentsPdfVo detail(Long id) {
        DocumentsPdf documentsPdf = this.getOne(Wrappers.<DocumentsPdf>query().lambda().eq(DocumentsPdf::getDocumentId,id).eq(DocumentsPdf::getDataType,1));
        DocumentsPdfVo result = BeanUtil.toBean(documentsPdf, DocumentsPdfVo.class);
        if(ObjectUtils.isEmpty(result)){
            Documents documents = documentsService.detail(id);
            return null;
        }else{
            return result;
        }

    }

    @Override
    public void add(DocumentsPdfDto documentsPdfDto) {
        this.saveOrUpdate(documentsPdfDto);
    }

    @Override
    public void edit(DocumentsPdfDto documentsPdfDto) {
        this.updateById(documentsPdfDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
